;
; DRIVEX drive_letter checks if the specified drive is
; ready for reading
;
; (c) B.Meissner, 1992
;
;
;
PSP_OFS EQU 80H
CODE SEGMENT
        ASSUME CS:CODE, DS:CODE
        ORG 100H
START:  JMP ENTRY
        NAM DB 'G:\*.*',0,'$'
        s_message db 'Drive ready',13,10,'$'
        o_message db 'Drive inexistent',13,10,'$'
        e_message db 'Drive not ready',13,10,'$'
        u_message db 'Drive not specified',13,10
          db '       return code:    0     Drive ready',13,10
          db '                       1     No files in root directory of drive',13,10
          db '                      64     Drive not specified',13,10
          db '                     128     Drive not ready',13,10
          db '                     255     Drive inexistent',13,10,10,'$'
        n_message db 'No files in root directory',13,10,'$'
        a_message db 13,10
          db 'DRIVEX drive_letter  -  Checks, if drive ready   (c) B.Meiner, 1992-3',13,10,'$'
        copyright db 13,10
          db '*** DO NOT ATTEMPT AT PATCHING THE COPYRIGHT MESSAGE ! ***',13,10
          db '***                OTHERWISE THE PROGRAM               ***',13,10
          db '*** MIGHT WELL DO STRANGE THINGS WITH YOUR DRIVES !!!! ***',13,10,10,'$'
ENTRY:

        mov dx, offset a_message
        mov ah, 9
        INT 21H

        mov dx, 0
        mov ds, dx
        mov si, 090h
        lodsw
        mov word ptr int_off, ax
        lodsw
        mov word ptr int_cs, ax
        mov dx, 0
        mov es, dx
        mov di, 090h
        mov ax, offset fehler
        stosw
        mov ax, cs
        stosw

        CALL   GET_FILENAME
        JNC CHECK
        MOV AX, CS
        MOV DS, AX
        MOV DX, OFFSET U_MESSAGE
        MOV AL, 64
        JMP SHORT BEENDE

check:
        mov ah,19h              ; get current drive
        int 21h
        mov byte ptr cur_drive,al

        mov dl, byte ptr nam
        sub dl,65

        mov byte ptr tar_drive, dl
        mov ah,0Eh              ; set current drive
        int 21h

        mov ah, 19h
        int 21h
        mov dl, byte ptr tar_drive
        cmp al,dl

        je drive_exist

        mov ah,0Eh
        mov dl,byte ptr cur_drive
        int 21h

        jmp short drive_noexist

drive_exist:

        mov ah,0Eh
        mov dl,byte ptr cur_drive
        int 21h


        xor cx, cx
        mov ax, cs
        mov ds, ax
        mov dx, offset nam
        mov ah, 04Eh
        int 21h
        jc no_file
        mov dx, offset s_message
        mov al, 00h
        jmp short beende

no_file:
        mov dx, offset n_message
        mov al, 01h
        jmp short beende

drive_noexist:
        mov dx, offset o_message
        mov al, 255
        jmp short beende


FEHLER:
        mov dx, cs
        mov ds, dx
        mov es, dx

        mov dx, offset e_message
        mov al, 128

beende:
        mov byte ptr r_code, al
        mov ah, 09
        int 21h

        mov dx, 0
        mov es, dx
        mov di, 090h
        mov ax, word ptr int_off
        stosw
        mov ax, word ptr int_cs
        stosw


        mov al, byte ptr r_code
        mov ah, 04Ch
        int 21h

int_cs  dw 0
int_off dw 0
r_code    db 00h
cur_drive db 00h
tar_drive db 00h


;
;
GET_FILENAME PROC
        MOV DX,CS
        MOV DS,DX
        MOV ES,DX
        MOV DI,PSP_OFS
        XOR CX,CX
        MOV CL,BYTE PTR ES:[DI]
;;;                                  ; I do not know, why, but many assaemblers do not take in this
;;;        JCXZ FEHL                 ; much shorter instruction
;;;                                  ; B.M.
        CMP CX, 0                    ; INSTEAD, WE USE MORE TRADITINAL CODING...
        JLE FEHL                     ;
        
        INC CX
;
LAB_1:  INC DI
        cmp byte ptr es:[di],9
        je next
        cmp byte ptr es:[di],32
        je next
        jmp short xget

next:
        dec cx
        cmp cx, 0
        jg lab_1
        jmp short fehl
;
xget:
        LEA SI,NAM
LAB_2:  MOV AL,BYTE PTR ES:[DI]
        cmp al,'z'
        jg fehl
        cmp al,'A'
        jl fehl
        cmp al, 'Z'
        jle lab_2ok
        cmp al,'a'
        JL FEHL
        sub al,32
lab_2ok:

        MOV BYTE PTR[SI],AL
;
ende:   CLC
        RET
;
FEHL: STC
        RET
GET_FILENAME ENDP


CODE ENDS
           END START

